## ros-noetic-mrpt-generic-sensor 0.0.3

=== CMakeLists.txt ===
if ("$ENV{ROS_VERSION}" STREQUAL "2")
	cmake_minimum_required(VERSION 3.8)
	set(PACKAGE_ROS_VERSION 2)
	set(ROS_2 TRUE)
else()
	cmake_minimum_required(VERSION 3.1)
	set(PACKAGE_ROS_VERSION 1)
	set(ROS_1 TRUE)
endif()

project(mrpt_generic_sensor)

# -----------------------------------------
# ROS 1
# -----------------------------------------
if (ROS_1)
	# Find catkin macros and# libraries
	# if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
	# is used, also find other catkin packages
	find_package(catkin REQUIRED COMPONENTS
		roscpp
		mrpt_sensorlib
	)

	###################################
	## catkin specific configuration ##
	###################################
	catkin_package(
		CATKIN_DEPENDS 
			mrpt_sensorlib
			roscpp
	)

	find_package(mrpt-ros1bridge REQUIRED)
endif()

# -----------------------------------------
# ROS 2
# -----------------------------------------
if (ROS_2)
	# find dependencies
	find_package(ament_cmake REQUIRED)
	find_package(mrpt_sensorlib REQUIRED)
	find_package(mrpt_msgs REQUIRED)
	
	find_package(mrpt-ros2bridge REQUIRED)
endif()

# Common ROS1/ROS2 deps:
find_package(mrpt-hwdrivers REQUIRED)

###########
## Build ##
###########

if (catkin_INCLUDE_DIRS)
	include_directories(${catkin_INCLUDE_DIRS})
endif()

## Declare a cpp executable
add_executable(${PROJECT_NAME}_node src/${PROJECT_NAME}_node.cpp)

target_compile_definitions(${PROJECT_NAME}_node PUBLIC
  PACKAGE_ROS_VERSION=${PACKAGE_ROS_VERSION}
)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	# High level of warnings.
	target_compile_options(${PROJECT_NAME}_node PRIVATE -Wall -Wextra -Wpedantic)
endif()

if (ROS_1)
	# Add cmake target dependencies of the executable/library
	# as an example, message headers may need to be generated before nodes
	add_dependencies(${PROJECT_NAME}_node
	${catkin_EXPORTED_TARGETS}
	)
endif()

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}_node
   ${catkin_LIBRARIES}
   mrpt::hwdrivers
)
if (ROS_1)
	target_link_libraries(${PROJECT_NAME}_node
		${catkin_LIBRARIES}
		mrpt::ros1bridge
	)
else()
	ament_target_dependencies(${PROJECT_NAME}_node
		mrpt_sensorlib
	)

	target_link_libraries(${PROJECT_NAME}_node
		mrpt::ros2bridge
		#mrpt_sensorlib #??
		)
endif()


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html


# Mark executables and/or libraries for installation
if (ROS_2)
	set(CATKIN_PACKAGE_LIB_DESTINATION lib)
	set(CATKIN_PACKAGE_BIN_DESTINATION bin)
	set(CATKIN_PACKAGE_INCLUDE_DESTINATION include)

	#ament_export_dependencies() # ???
endif()

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

#############
## Testing ##
#############

## ros-noetic-mrpt-generic-sensor 0.0.2

=== debian/changelog ===
ros-noetic-mrpt-generic-sensor (0.0.2-1buster) buster; urgency=high

  * New package
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 23 Jun 2022 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-mrpt-generic-sensor
Section: misc
Priority: optional
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-mrpt-sensorlib, ros-noetic-mrpt2, ros-noetic-roscpp
Homepage: https://wiki.ros.org/mrpt_sensors
Standards-Version: 3.9.2

Package: ros-noetic-mrpt-generic-sensor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-mrpt-sensorlib, ros-noetic-mrpt2, ros-noetic-roscpp
Description: ROS node for interfacing any sensor supported by mrpt-hwdrivers

## ros-noetic-mrpt-generic-sensor 0.0.3

=== debian/changelog ===
ros-noetic-mrpt-generic-sensor (0.0.3-1focal) focal; urgency=high

  * towards templatized specific sensor nodes
  * Contributors: Jose Luis Blanco Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Tue, 13 Jun 2023 22:00:00 -0000

ros-noetic-mrpt-generic-sensor (0.0.2-1focal) focal; urgency=high

  * New package
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 23 Jun 2022 22:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
-Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-mrpt-sensorlib, ros-noetic-mrpt2, ros-noetic-roscpp
+Build-Depends: debhelper (>= 9.0.0), cmake, ros-noetic-catkin, ros-noetic-mrpt-sensorlib, ros-noetic-mrpt2, ros-noetic-ros-environment, ros-noetic-roscpp
 Homepage: https://wiki.ros.org/mrpt_sensors
 Standards-Version: 3.9.2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-mrpt-generic-sensor//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
